"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MDXContent;
var _react = _interopRequireDefault(require("react"));
var _react2 = require("@mdx-js/react");
var _excluded = ["components"]; // @ts-nocheck
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
/* @jsxRuntime classic */
/* @jsx mdx */

var layoutProps = {};
var MDXLayout = "wrapper";
function MDXContent(_ref) {
  var components = _ref.components,
    props = _objectWithoutProperties(_ref, _excluded);
  return (0, _react2.mdx)(MDXLayout, _extends({}, layoutProps, props, {
    components: components,
    mdxType: "MDXLayout"
  }), (0, _react2.mdx)("h2", null, "Background"), (0, _react2.mdx)("p", null, "Bit's build process is an extensible CI for independent components. It validates a component is not dependent on its context (the workspace), tests it, and generates all artifacts necessary for it to be viewed and consumed as an independent module (its distributable code, bundled preview, etc.)."), (0, _react2.mdx)("p", null, "The Build Pipeline is an Environment Service responsible for sequencing and executing a component's Build Tasks. As mentioned earlier, these tasks are performed on a component only after it's been isolated from the rest of the workspace."), (0, _react2.mdx)("p", null, "A component's default series of Build Tasks is composed of tasks set by Bit and by its environment."), (0, _react2.mdx)("h2", null, "Isolated builds"), (0, _react2.mdx)("p", null, "Components authored in a Bit workspace are created to be completely portable, and thus independent. To address that, the build process starts by creating a component 'capsule' which is an isolated instance of a component, generated in a separate directory in your filesystem."), (0, _react2.mdx)("p", null, "As part of the capsule creation, all packages listed as dependencies of that component will be installed. This step is necessary to validate there are no dependency-graph issues (a component that is not totally isolated will be able to use packages installed in parent directories in your workspace, by other components. This will translate into a \"false positive\" result when testing for dependency-graph issues in a non-isolated location)."), (0, _react2.mdx)("h2", null, "Incremental builds"), (0, _react2.mdx)("p", null, "When a component \"goes through\" the build pipeline, all of its dependencies are built as well. If a dependency has not changed since its last build, the build process will use its artifacts from the previous build (and will not process it again). This optimization to the build process supplements the \"innate optimization\" that naturally comes from developing (and building) independent components instead of a single monolithic codebase."), (0, _react2.mdx)("h2", null, "Environment-specific builds"), (0, _react2.mdx)("p", null, "Each Bit environment determines its own build pipeline. That means, a single workspace that uses multiple environments will run a different set of build tasks on different components depending on their associated environment. This is another Bit feature that enables seamless transitioning between different development environments, all in the same workspace. It also makes it much easier to integrate the Build Pipeline in your (remote) CI, as it only requires executing the build step - all other per-component build configurations are already set by the various environments being used."), (0, _react2.mdx)("p", null, "Since environments are extensible, so are the build pipelines configured by them."), (0, _react2.mdx)("h2", null, "Build task"), (0, _react2.mdx)("p", null, "An example of a build-task is ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "compile"), ", it's written in the compiler aspect and is running on each one of the capsules created by the build process. build-tasks in many cases generate artifacts, in this case, the compiler generates ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dists"), " files and write them on the isolated capsules. There artifacts files are used later for example when creating packages."), (0, _react2.mdx)("h2", null, "Pipelines"), (0, _react2.mdx)("p", null, "There are three pipelines: ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "build"), ", ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "tag"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "snap"), "."), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit build"), " runs the build pipeline."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit tag"), " runs the build pipeline and then the tag pipeline."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit snap"), " runs the build pipeline and then the snap pipeline.")), (0, _react2.mdx)("h2", null, "List Build Tasks"), (0, _react2.mdx)("p", null, "To get a list of all the tasks that will be running per pipeline on a specific component, run ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit build --list-tasks <id>"), ".\nHere is an example of the relevant part from the output:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre"
  }, "\u279C  bit build --list-tasks ui/tooltip\nTasks List\nid:    teambit.design/ui/tooltip@0.0.347\nenvId: teambit.react/react\n\nBuild Pipeline Tasks:\nteambit.harmony/aspect:CoreExporter\nteambit.compilation/compiler:TSCompiler\nteambit.defender/tester:TestComponents\nteambit.pkg/pkg:PreparePackages\nteambit.pkg/pkg:PublishDryRun\nteambit.preview/preview:GeneratePreview\n\nTag Pipeline Tasks:\nteambit.harmony/application:build_ui_application\nteambit.pkg/pkg:PublishComponents\n\nSnap Pipeline Tasks:\n<N/A>\n")), (0, _react2.mdx)("h2", null, "Implementing Build Tasks"), (0, _react2.mdx)("p", null, "The ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "BuildTask"), " interface is a good start to understand how to implement a new build-task.\nWhen writing a build task, the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "Network"), " object is passed and it includes the seeders capsules, as well as the entire graph including the dependencies.\nKeep in mind that the entire graph may contain components from other envs."), (0, _react2.mdx)("p", null, "Some tasks, such as, compiling in typescript and bundling with Webpack, need the entire graph.\nOthers, such as, Babel, need only the seeders. However, normally, the bundling is running after the compilation and it expects to have the dependencies compiled, so you might need the entire graph regardless."), (0, _react2.mdx)("h2", null, "Adding Tasks to a pipeline"), (0, _react2.mdx)("p", null, "There are two ways of adding tasks to the build pipeline."), (0, _react2.mdx)("ol", null, (0, _react2.mdx)("li", {
    parentName: "ol"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "getBuildPipe()"), " method of the env. (or ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "getTagPipe()"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "getSnapPipe()"), ")"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "registering to the slot via ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "builder.registerBuildTask()"), ". (or ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "registerTagTask()"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "registerSnapTask()"), ")")), (0, _react2.mdx)("p", null, "in the option #1, it's possible to determine the order. e.g. ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getBuildPipe() { return [taskA, taskB, taskC]; }"), "\nin the option #2, the register happens once the extension is loaded, so there is no way to put\none task before/after another task as of now."), (0, _react2.mdx)("h2", null, "Sequencing the build tasks"), (0, _react2.mdx)("p", null, "The Build Pipeline takes into consideration the following factors when deciding the order of which to execute each task:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "Location"), ": A task can be executed either at the start or end of the build pipeline. This can be explicitly configured by the task itself."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "Dependencies"), ": A task can depend on other tasks. That means, the dependencies must be completed successfully for all envs before this task starts. The dependencies are applicable inside a location and not across locations. This is configured by the task itself."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("strong", {
    parentName: "li"
  }, "An environment's list of build tasks"), ": This is the array of tasks as it is defined by an environment")), (0, _react2.mdx)("h2", null, "Executing the pipelines"), (0, _react2.mdx)("p", null, "Commands that trigger the build pipeline:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit build"), " - runs the build pipeline on your local machine, for the entire workspace. The output data will not persist. - That is most often used for testing and debugging the build process."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit tag"), " - runs the tag pipeline in addition to the build pipeline, before creating a new component release version. The output data will persist."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "bit snap"), " - runs the snap pipeline in addition to the build pipeline. The output data will persist.")), (0, _react2.mdx)("p", null, "Build pipelines are determined by the environments in use. That means, in order to override the default pipeline, we need to create a new environment extension or modify an existing one."), (0, _react2.mdx)("p", null, "The example task below, shown being used by a customized environment, prints out the component name of every component handled by it. In addition to that, the task returns the component name as custom metadata to be logged and/or stored in the component tagged version. ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://github.com/teambit/harmony-build-examples"
  }, "See a demo project here"), "."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Information returned by a build task will only persist if the build-pipeline was triggered by the 'hard-tag' command (", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit tag <component-id>"), ").")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts",
    "metastring": "title=\"print-cmp-name-task.ts\"",
    "title": "\"print-cmp-name-task.ts\""
  }, "import { BuildTask, BuildContext, BuiltTaskResult, ComponentResult } from '@teambit/builder';\n\n// A task is an implementation of 'BuildTask' provided by the 'builder' aspect\nexport class PrintCmpNameTask implements BuildTask {\n  // The constructor leaves these properties up to the hands of the environment using this task\n  constructor(\n    readonly aspectId: string,\n    readonly name: string\n  ) {}\n\n  // This is where the task logic is placed. It will be executed by the build pipeline\n  async execute(context: BuildContext): Promise<BuiltTaskResult> {\n    const componentsResults: ComponentResult[] = [];\n\n    // Go through every isolated component instance\n    context.capsuleNetwork.seedersCapsules.forEach((capsule) => {\n      console.log(`The current component name is: ${capsule.component.id.name}`);\n\n      componentsResults.push({\n        component: capsule.component,\n        metadata: { customProp: capsule.component.id.name },\n      });\n    });\n    return {\n      // An array of component objects, enriched with additional data produced by the task\n      componentsResults,\n    };\n  }\n}\n")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts",
    "metastring": "title=\"customized-react.extension.ts\"",
    "title": "\"customized-react.extension.ts\""
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactAspect, ReactMain } from '@teambit/react';\n\n// Import the task\nimport { PrintCmpNameTask } from './print-cmp-name-task';\n\nexport class CustomReact {\n  constructor(private react: ReactMain) {}\n\n  static dependencies: any = [EnvsAspect, ReactAspect];\n\n  static async provider([envs, react]: [EnvsMain, ReactMain]) {\n    // Get the environment's default build pipeline\n    const reactPipe = react.env.getBuildPipe();\n\n    // Add the custom task to the end of the build tasks sequence.\n    // Provide the task with the component ID of the extension using it.\n    // Provide the ask with a name.\n    const tasks = [...reactPipe, new PrintCompTask('extensions/custom-react', 'PrintCmpNameTask')];\n\n    // Create a new environment by merging these configurations with the env's default ones\n    const customReactEnv = react.compose([react.overrideBuildPipe(tasks)]);\n\n    // register the extension as an environment\n    envs.registerEnv(customReactEnv);\n    return new CustomReact(react);\n  }\n}\n")), (0, _react2.mdx)("h2", null, "Positioning a build task in the pipeline"), (0, _react2.mdx)("p", null, "A build task is positioned in the build pipeline sequence either by overriding the entire ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "customizable"), " pipeline or, by registering it to a location in the pipeline using the designated builder slot."), (0, _react2.mdx)("h3", null, "Override the build pipeline sequence"), (0, _react2.mdx)("p", null, "This methodology leaves the task completely agnostic as to its position in the build pipeline. Instead, the task position is determined by the environment using the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getBuildPipe"), " Environment Handler."), (0, _react2.mdx)("p", null, "The example above shows the React environment ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "overrideBuildPipe"), " method being used to override its default pipeline. This method uses the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getBuildPipe()"), " Environment Handler, internally."), (0, _react2.mdx)("h3", null, "Append to the start or end of the pipeline, in relation to other tasks"), (0, _react2.mdx)("p", null, "This methodology places the task at the start or end of the build pipeline sequence, and lists all other tasks needed to run successfully before it is executed."), (0, _react2.mdx)("p", null, "Example:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts",
    "metastring": "title=\"print-cmp-name-task.ts\"",
    "title": "\"print-cmp-name-task.ts\""
  }, "import { BuildTask, BuildContext, BuiltTaskResult, ComponentResult } from '@teambit/builder';\n\nexport class PrintCmpNameTask implements BuildTask {\n  constructor(\n    readonly aspectId: string,\n    readonly name: string\n  ) {}\n\n  // Place the task at the end of the build pipeline\n  readonly location = 'end';\n\n  // Run this task only after the '@teambit/preview' task is completed successfully\n  readonly dependencies = ['@teambit/preview'];\n\n  async execute(context: BuildContext): Promise<BuiltTaskResult> {\n    const componentsResults: ComponentResult[] = [];\n    context.capsuleNetwork.seedersCapsules.forEach((capsule) => {\n      console.log(`The current component name is: ${capsule.component.id.name}`);\n\n      componentsResults.push({\n        component: capsule.component,\n        metadata: { customProp: capsule.component.id.name },\n      });\n    });\n    return {\n      componentsResults,\n    };\n  }\n}\n")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts",
    "metastring": "title=\"customized-react.extension.ts\"",
    "title": "\"customized-react.extension.ts\""
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactAspect, ReactMain } from '@teambit/react';\nimport { BuilderMain } from '@teambit/builder';\n\n// Import the task (in reality, it should be an independent component)\nimport { PrintCmpNameTask } from './print-cmp-name-task';\n\nexport class CustomReact {\n  constructor(private react: ReactMain) {}\n\n  static dependencies: any = [EnvsAspect, ReactAspect];\n\n  // Inject the builder\n  static async provider([envs, react, builder]: [EnvsMain, ReactMain, BuilderMain]) {\n    // Register this task using the registration slot, made available by the 'builder'.\n    // Here, the environment has no say in the positioning of the task\n    builder.registerBuildTasks([new ExampleTask('extensions/custom-react', 'PrintCmpNameTask')]);\n\n    const customReactEnv = react.compose([]);\n\n    envs.registerEnv(customReactEnv);\n    return new CustomReact(react);\n  }\n}\n")), (0, _react2.mdx)("h2", null, "A build task anatomy"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "aspectId"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "aspectId: string"), (0, _react2.mdx)("br", null), "\nThe component ID of the environment using this task.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "name"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "name: string"), " ", (0, _react2.mdx)("br", null), "\nA name for this task. Only alphanumerical characters are allowed. PascalCase should be used as a convention.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "location"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "location?: 'start' | 'end'"), " ", (0, _react2.mdx)("br", null), "\nThe section of the build-pipeline to which to append this task.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "dependencies"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dependencies?: string[]"), " ", (0, _react2.mdx)("br", null), "\nAn list of tasks that must be completed before this task gets executed. ", (0, _react2.mdx)("br", null), "\nFor example ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dependencies = ['@teambit/preview']"), ".")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "execute"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "execute(context: BuildContext): Promise<BuiltTaskResult>"), " ", (0, _react2.mdx)("br", null), "\nThe execute method is where all the task logic is placed."), (0, _react2.mdx)("ul", {
    parentName: "li"
  }, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "context"), " (argument) ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "context: BuildContext"), " ", (0, _react2.mdx)("br", null), "\nThe context of the build pipeline. Use this object (provided by the build pipeline) to get information regarding all components handled by the build pipeline. ", (0, _react2.mdx)("br", null), (0, _react2.mdx)("br", null), "\nFor example, ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "context.capsuleNetwork.seedersCapsules"), " are models representing isolated instances of components handled by the build pipeline. These isolated instances are independent projects, generated in your local filesystem (by the build pipeline).")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "return"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "Promise<BuiltTaskResult>"), " ", (0, _react2.mdx)("br", null), "\nA ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "context"), " method returns an object with data regarding the build task process, additional data regarding the components handled by the task and, if available, data regarding the different artifacts generated by this task.", (0, _react2.mdx)("br", null), "\nThe returned object has the following attributes:"), (0, _react2.mdx)("ul", {
    parentName: "li"
  }, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "componentsResults"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "componentsResults: ComponentResult[]"), "\nAn array of objects, each containing an instance of an object handled the task and additional information regarding the process and the component itself.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "component"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "component: Component"), " ", (0, _react2.mdx)("br", null), "\nAn instance of the component handled by the task (see the above task example).")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "metadata"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "metadata?: { [key: string]: Serializable }"), " ", (0, _react2.mdx)("br", null), "\nComponent metadata generated during the build task.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "errors"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "errors?: Array<Error | string>"), " ", (0, _react2.mdx)("br", null), "\nBuild task errors. A task returning errors will abort the build pipeline and log the returned errors.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "warnings"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "warnings?: string[]"), " ", (0, _react2.mdx)("br", null), "\nwarnings generated throughout the build task.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "startTime"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "startTime?: number"), " ", (0, _react2.mdx)("br", null), "\nA timestamp (in milliseconds) of when the task started")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "endTime"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "endTime?: number"), " ", (0, _react2.mdx)("br", null), "\nA timestamp (in milliseconds) of when the task ended")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "artifacts"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "artifacts?: ArtifactDefinition[]"), " ", (0, _react2.mdx)("br", null), "\nAn array of artifact definitions to generate after a successful build")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "name"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "name: string"), " ", (0, _react2.mdx)("br", null), "\nThe name of the artifact. ", (0, _react2.mdx)("br", null), "\nFor example, a project might utilize two different artifacts for the same typescript compiler, one that generates ES5 files and another for ES6. This prop helps to distinguish between the two.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "generatedBy"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "generatedBy?: string;"), " ", (0, _react2.mdx)("br", null), "\nId of the component that generated this artifact.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "description"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "description?: string"), " ", (0, _react2.mdx)("br", null), "\nA description of the artifact. ", (0, _react2.mdx)("br", null))), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "globPatterns"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "globPatterns: string[]"), " ", (0, _react2.mdx)("br", null), "\nGlob patterns of files to include upon artifact creation. Minimatch is used to match the patterns. ", (0, _react2.mdx)("br", null), "\nFor example, ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "['*.ts', '!foo.ts']"), " matches all ts files but ignores ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "foo.ts"), ".")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "rootDir"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "rootDir?: string"), " ", (0, _react2.mdx)("br", null), "\nDefines the root directory of the artifacts in the capsule file system. The rootDir must be unique for every artifact, otherwise data might be overridden.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "dirPrefix"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dirPrefix?: string"), " ", (0, _react2.mdx)("br", null), "\nAdds a directory prefix for all artifact files.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "context"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "context?: 'component' | 'env'"), " ", (0, _react2.mdx)("br", null), "\nDetermine the context of the artifact. The default artifact context is ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "component"), ". ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "env"), " is useful when the same file is generated for all components, for example, a \"preview\" task may create the same webpack file for all components of that env.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "storageResolver"), " ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "storageResolver?: string"), " ", (0, _react2.mdx)("br", null), "\nUsed to replace the location of the stored artifacts. The default resolver persists artifacts on scope (that's not recommended for large files).")))))), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "preBuild"), " (advanced) ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "preBuild?(context: BuildContext): Promise<void>"), " ", (0, _react2.mdx)("br", null), "\nRuns before the build pipeline has started. This method should only be used when preparations are needed to be done on all environments before the build starts.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "postBuild"), " (advanced) ", (0, _react2.mdx)("br", null), "\n", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "postBuild?(context: BuildContext, tasksResults: TaskResultsList): Promise<void>"), " ", (0, _react2.mdx)("br", null), "\nRuns after the dependencies were completed for all environments."))));
}
;
MDXContent.isMDXComponent = true;

//# sourceMappingURL=builder.mdx.js.map